/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.wpa.webservices.service;

import cz.cvut.kbss.wpa.webservices.Data;
import cz.cvut.kbss.wpa.webservices.model.Book;
import java.util.ArrayList;
import java.util.List;
import org.springframework.stereotype.Service;

/**
 *
 * @author marek
 */
@Service
public class BookService implements BookServiceIface {

    @Override
    public Book getBookById(long id) {
        for (Book b : Data.getBooks()) {
            if (b.getId() == id) {
                return b;
            }
        }
        return null;
    }

    @Override
    public List<Book> getAllBooks() {
        return Data.getBooks();
    }

    @Override
    public List<Book> getBooksByTitle(String title) {
        List<Book> res = new ArrayList<Book>();
        for (Book b : Data.getBooks()) {
            if (b.getTitle().toLowerCase().contains(title.toLowerCase())) {
                res.add(b);
            }
        }
        return res;
    }

    @Override
    public List<Book> getBooksByOwnerName(String name) {
        List<Book> res = new ArrayList<Book>();
        for (Book b : Data.getBooks()) {
            if (b.getOwner().getUserName().toLowerCase().contains(name.toLowerCase())) {
                res.add(b);
            }
        }
        return res;
    }

    @Override
    public List<Book> getBooksByOwnerAge(int min, int max) {
        List<Book> res = new ArrayList<Book>();
        for (Book b : Data.getBooks()) {
            if ((b.getOwner().getAge() >= min) && (b.getOwner().getAge() <= max)) {
                res.add(b);
            }
        }
        return res;
    }

    @Override
    public void addBook(Book book) {
        Data.getBooks().add(book);
    }

}
